package com.gyee.runeconomy.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @ClassName : R
 * @Author : xieshengjie
 * @Date: 2021/5/16 16:59
 * @Description : 结果集
 */
@Data
public class ResultMsg {
    @ApiModelProperty(value = "是否成功")
    private Boolean success;
    @ApiModelProperty(value = "返回码")
    private Integer code;
    @ApiModelProperty(value = "返回消息")
    private String message;
    @ApiModelProperty(value = "总数量")
    private Integer count;
    @ApiModelProperty(value = "返回数据")
    private Object data = new Object();

    public ResultMsg() {
    }

    public static ResultMsg ok() {
        ResultMsg r = new ResultMsg();
        r.setSuccess(true);
        r.setCode(ResultCode.SUCCESS);
        r.setMessage("成功");
        return r;
    }


    public static ResultMsg ok(Object data) {
        ResultMsg r = new ResultMsg();
        r.setSuccess(true);
        r.setCode(ResultCode.SUCCESS);
        r.setData(data);
        r.setMessage("成功");
        return r;
    }

    public static ResultMsg ok(Object data, Integer count) {
        ResultMsg r = new ResultMsg();
        r.setSuccess(true);
        r.setCode(ResultCode.SUCCESS);
        r.setData(data);
        r.setMessage("成功");
        r.setCount(count);
        return r;
    }


    public static ResultMsg ok(Integer count) {
        ResultMsg r = new ResultMsg();
        r.setSuccess(true);
        r.setCode(ResultCode.SUCCESS);
        r.setMessage("成功");
        r.setCount(count);
        return r;
    }

    public static ResultMsg error() {
        ResultMsg r = new ResultMsg();
        r.setSuccess(false);
        r.setCode(ResultCode.ERROR);
        r.setMessage("失败");
        return r;
    }


    public ResultMsg success(Boolean success) {
        this.setSuccess(success);
        return this;
    }

    public ResultMsg message(String message) {
        this.setMessage(message);
        return this;
    }

    public static ResultMsg errorMsg(String msg) {
        ResultMsg r = new ResultMsg();
        r.setSuccess(false);
        r.setCode(ResultCode.ERROR);
        r.setMessage(msg);
        return r;
    }

    public ResultMsg code(Integer code) {
        this.setCode(code);
        return this;
    }

    public ResultMsg data(Object value) {
        this.setData(value);
        return this;
    }
}
